
#include <stdio.h>
#include <math.h>
/* beruecksichtigt dur und moll Dreiklaenge sowie septakkorde
                     gross und klein
 */
int tonvect[128], chan, onoff, zeit, ton, vol, chanx, onoffx, zeitx, tonx,
  volx, chanwahl, i, j, bit = 1, p, konez = 0, zeitalt, n;
static char leitern[13][3] =
{
  "c", "c#", "d", "d#", "e", "f", "f#", "g", "g#", "a", "a#", "h"};
static int mask[12] =
{
  1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048};
 struct akko
    {
      int num;
      char name[20];
    ;int frq;};
static  struct akko akkor[] =
  {
{  137 ,  " c_moll",0},
{  145 ,  " c_dur",0},
{  265 ,  " gis_dur",0},
{  274 ,  " cis_moll",0},
{  275  ,  "cis_moll_septgr",0},
{  289 ,  " f_moll",0},
{  290 ,  " cis_dur",0},
{  291  , " cis_dur_septgr",0},
{  297  ,  "f_moll_septkl",0},
{  305  ,  "f_moll_septgr",0},
{  329  ,  "gis_dur_septkl",0},
{  393  , " gis_dur_septgr",0},
{  529 ,  " a_moll",0},
{  530 ,  " a_dur",0},
{  545 ,  " f_dur",0},
{  548 ,  " d_moll",0},
{  549  ,  "d_moll_septkl",0},
{  550  ,  "d_moll_septgr",0},
{  553  ,  "f_dur_septkl",0},
{  561  , " f_dur_septgr",0},
{  578 ,  " fis_moll",0},
{  580 ,  " d_dur",0},
{  581  ,  "d_dur_septkl",0},
{  582  , " d_dur_septgr",0},
{  594  ,  "fis_moll_septkl",0},
{  610  ,  "fis_moll_septgr",0},
{  657  ,  "a_moll_septkl",0},
{  658  ,  "a_dur_septkl",0},
{  785  ,  "a_moll_septgr",0},
{  786  , " a_dur_septgr",0},
{ 1058 ,  " ais_moll",0},
{ 1060 ,  " ais_dur",0},
{ 1090 ,  " fis_dur",0},
{ 1096 ,  " dis_moll",0},
{ 1098  ,  "dis_moll_septkl",0},
{ 1100  ,  "dis_moll_septgr",0},
{ 1106  ,  "fis_dur_septkl",0},
{ 1122  , " fis_dur_septgr",0},
{ 1156 ,  " g_moll",0},
{ 1160 ,  " dis_dur",0},
{ 1161  ,  "c_moll_septkl",0},
{ 1162  ,  "dis_dur_septkl",0},
{ 1164  , " dis_dur_septgr",0},
{ 1169  ,  "c_dur_septkl",0},
{ 1188  ,  "g_moll_septkl",0},
{ 1220  ,  "g_moll_septgr",0},
{ 1314  ,  "ais_moll_septkl",0},
{ 1316  ,  "ais_dur_septkl",0},
{ 1570  ,  "ais_moll_septgr",0},
{ 1572  , " ais_dur_septgr",0},
{ 2116 ,  " h_moll",0},
{ 2120 ,  " h_dur",0},
{ 2180 ,  " g_dur",0},
{ 2185  ,  "c_moll_septgr",0},
{ 2192 ,  " e_moll",0},
{ 2193  , " c_dur_septgr",0},
{ 2196  ,  "e_moll_septkl",0},
{ 2200  ,  "e_moll_septgr",0},
{ 2212  ,  "g_dur_septkl",0},
{ 2244  , " g_dur_septgr",0},
{ 2312 ,  " gis_moll",0},
{ 2320 ,  " e_dur",0},
{ 2322  ,  "cis_moll_septkl",0},
{ 2324  ,  "e_dur_septkl",0},
{ 2328  , " e_dur_septgr",0},
{ 2338  ,  "cis_dur_septkl",0},
{ 2376  ,  "gis_moll_septkl",0},
{ 2440  ,  "gis_moll_septgr",0},
{ 2628  ,  "h_moll_septkl",0},
{ 2632  ,  "h_dur_septkl",0},
{ 3140  ,  "h_moll_septgr",0},
{ 3144  , " h_dur_septgr",0},
{ 0,"",0}};
/*--------------- u.progr. akkorde -------------------------------*/
int
akkorde (int x)
{
  int i, j, k, l, n;
  i = 0;
  while ((x != akkor[i].num) && (akkor[i].num != 0))
    i++;
  if (akkor[i].num != 0)
    {
      printf ("%s\n", akkor[i].name);
      /*sleep (2);*/ akkor[i].frq++;
    }

}
/*------------- Auswertprogramm ------------------------------------------*/
int
auswert ()
{
  static int i, ahton, azton, atime, n = 0, zton, lton, bin, bini;
  static float sdhton = 0, sdzton = 0, sdtime = 0, sqdhton = 0;
  if (konez)
    {
      printf ("nu is vorbei  nach  %d records\n\n", n);
      printf ("intva-su %f sdtime %f sdzton %f\n\n", sdhton, sdtime, sdzton);
      printf ("intva-mi %f dtime-mi %f dzton-mi %f\n\n", sdhton / n, sdtime / n, sdzton / n);
      printf ("summe der quadrate der intervalle %f\n\n", sqdhton);
      printf ("varianz der intervalle %f\n\n", sqdhton / n);
      printf ("standardabweichung der intervalle %f\n", sqrt (sqdhton / n));
for(i=0;i<72;i++)if (akkor[i].frq != 0) printf("%7d mal  %s\n",akkor[i].frq,akkor[i].name);
    }
  else
    {
      zton = 0;
      bin = 0;
      for (i = 0; i < 128; i++)
	if (tonvect[i] != 0)
	  {
	    bini = pow (2, i % 12);
	    bin = bin | bini;
	    printf ("%d  ", i);   
	    zton++;
	    if (zton != 0)
	      lton = i;
	  }
      if (zton > 2)
	akkorde (bin);
      if (zton == 0)
	return;
      n++;
      if (n > 1)
	{
	  printf ("\n");
	  /*printf("letzt.ton %d tonanz. %d\n",lton,zton); */
	  sdhton = sdhton + lton - ahton;
	  sqdhton = sqdhton + pow ((lton - ahton), 2);
	  sdtime = sdtime + zeit - atime;
	  sdzton = sdzton + zton;
	}
      ahton = lton;
      atime = zeit;
      azton = zton;
    }
}






/*==============================Hauptprogramm============================*/
int
main (cpar, vpar)
     int cpar;
     char *vpar[];
{
/*.................Eroeffnung........................................... */
  if (cpar < 2)
    goto schluss;
  chanwahl = 0;
  for (i = 0; i < 128; i++)
    tonvect[i] = 0;
  fprintf (stderr, "%s\n", vpar[1]);
/*.........................Kanalwahl.................................... */
  for (n = 1; n < cpar; n++)
    {
      i = atoi (vpar[n]);
      fprintf (stderr, "%d\n", i);
      if ((i < 0) || (i > 15))
	goto schluss;
      bit = 1;
      bit = bit << i;
      chanwahl = chanwahl | bit;
    }

  fprintf (stderr, "%30d %30x\n", chanwahl, chanwahl);
  /*...................Einlesen und auswaehlen.......................... */
  while (scanf ("%d%d%d%d%d", &chanx, &onoffx, &zeitx, &tonx, &volx) == 5)
    {
      if (zeitx - zeitalt > 0)
	auswert ();
      chan = chanx;
      onoff = onoffx;
      zeit = zeitx;
      ton = tonx;
      vol = volx;
      p = 1;
      p = p << chan;
      if ((p & chanwahl) != 0)
	{
	  if (onoff)
	    {
	      tonvect[ton] = vol;
	    }
	  else
	    tonvect[ton] = 0;
	  printf ("%55d  %d  %d  %d  %d \n", chan, onoff, zeit, ton, vol);
	  zeitalt = zeit;

	}
    }
  konez = 1;
  auswert ();
  goto ok;
schluss:puts ("Abbruch, Fehleingabe");
ok:puts(" nu is't oewer uut !");
}
